<? 
// Use this method only if the frequency in the original payment request is NONE

// To use this method for taking future payments in a cycle, 
// ce_cyclemgt must be "No" or empty and frequency must be "none" in the original payment request

function pay($token,$transref,$mertid,$sign,$amount=''){
	$request = 'amount='.$amount.'&mertid='.$mertid.'&transref='.$transref.'&last_transref='.$token.'&signature='.$sign; //initialize the request variables
	$url = 'https://www.cashenvoy.com/sandbox2/?cmd=ce_rcpay'; //this is the url of the gateway's test api
	//$url = 'https://www.cashenvoy.com/webservice/?cmd=ce_rcpay'; //this is the url of the gateway's live api
	$ch = curl_init(); //initialize curl handle
	curl_setopt($ch, CURLOPT_URL, $url); //set the url
	curl_setopt($ch, CURLOPT_RETURNTRANSFER,true); //return as a variable
	curl_setopt($ch, CURLOPT_POST, 1); //set POST method
	curl_setopt($ch, CURLOPT_POSTFIELDS, $request); //set the POST variables
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);//change to true when live
	$response = curl_exec($ch); // grab URL and pass it to the browser. Run the whole process and return the response
	curl_close($ch); //close the curl handle
	return $response;	
}

$key = 'merchantkey';
$mertid = 1;

//MANDATORY - Reference for transaction in the payment cycle for which payment is about to be taken
$transref = 'DM123456789012';

//OPTIONAL - The token is the also the reference for the very first transaction in this cycle
//Only required if this is the first attempt to take payment for transaction specified in $transref
$token = 'CRC12437556351';

//OPTIONAL - The amount associated with transaction specified in $transref
//Only required if 
//1) this is the first attempt to take payment for transaction specified in $transref AND
//2) the associated payment cycle frequency = none
$amount = 3422.77;


//If not providing amount, use "$cdata = $key.$transref.$mertid;"
$cdata = $key.$transref.$mertid.$amount;

$signature = hash_hmac('sha256', $cdata, $key, false);
$response = pay($token,$transref,$mertid,$signature,$amount);


/*------------------------------------- processing response in json format ---------------------------*/
/*
PHP 5 >= 5.2.0, PECL json >= 1.2.0 
Go to http://php.net/manual/en/function.json-decode.php for more information */

$data = json_decode($response);
foreach ($data as $subdata) { 
	@$cnt++; 
}
if($cnt==3){ 
	$returned_transref = $data->{'TransactionId'};
	$returned_status = $data->{'TransactionStatus'};
	$returned_amount = $data->{'TransactionAmount'};
    //Only 2 response codes possible; Response of C00 indicates success; Response of C05 indicates failure;
    //Confirm amount before providing service    
} else {
	$errorMsg = $data->{'TransactionStatus'};
}
	
?>